import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class Shooter extends Applet implements KeyListener{
	private boolean firstTime = true;
	public FlapWings flap;
	private Image shoot;
	private Image dead;
	private Image border;
	private Image head;
	private int position = 10;
	private int clearPos = 10;
	private int imageW = 0;
	private int imageH = 0;
	private int score = 0;
	private int level = 1;
	private Font font = new Font("Helvetica",Font.BOLD,13);
	private Button click;
	private int numOfHeads = 3;

	public Shooter(){
	}

	public void init(){
		setLayout(null);
		click = new Button("Restart");
		click.setBounds(525,190,60,23);
		add(click);
		setBackground(Color.white);
		head = getImage( getCodeBase(), "head.jpg" );
		dead = getImage( getCodeBase(), "blasted.jpg" );
		shoot = getImage( getCodeBase(), "shooter.jpg" );
		addKeyListener(this);
		int w = 600;
		int h = 460;
		border = createImage(w,h);
		Graphics g = border.getGraphics();
		g.setColor(Color.gray);
		g.fillRoundRect(0,0,w,h,10,10);
		g.setColor(Color.white);
		g.fillRoundRect(10,10,w-100,h-20,10,10);
		g.fillRoundRect(w-80,10,70,(h/2)-10,10,10);
		g.fillRoundRect(w-80,(h/2)+10,70,(h/2)-20,10,10);
		flap = new FlapWings(this,getGraphics());
		flap.start();
		requestFocus();
	}

	public void keyTyped(KeyEvent ke){
	}

	public void keyPressed(KeyEvent ke){
		clearPos = position;
		if( ke.getKeyCode() == ke.VK_LEFT && flap.getTotalDeaths() < 3 ){
			position -= 40;
			if( position < 10 ){
				position = 10;
			}
			repaint();
		}
		if( ke.getKeyCode() == ke.VK_RIGHT && flap.getTotalDeaths() < 3 ){
			position += 40;
			if( position > 460 ){
				position = 460;
			}
			repaint();
		}
		if( ke.getKeyCode() == ke.VK_SPACE && flap.getTotalDeaths() < 3 ){
			(new FireBullet(this,getGraphics(),position)).start();
		}
	}

	public void keyReleased(KeyEvent ke){
	}

	public void update(Graphics g){
		paint(g);
	}

	public void paint(Graphics g){
		g.drawImage(border,0,0,this);
		if( shoot == null ){
			return;
		}else if( firstTime ){
			if( shoot.getWidth(this) == -1 || shoot.getHeight(this) == -1 ){
				return;
			}
			imageW = shoot.getWidth(this);
			imageH = shoot.getHeight(this);
			firstTime = false;
		}
		if( position != clearPos ){
			g.setColor( Color.white );
			g.fillRect( clearPos , 390 , imageW , imageH );
		}
		if( flap.isHeroDead() ){
			g.drawImage( dead, position ,390,this);
			flap.setHeroDead(false);
		}else{
			g.drawImage( shoot, position ,390,this);
		}
		if( flap.getTotalDeaths() > 2 ){
			g.setColor( Color.black );
			String chr = "Looser. You're Dead 3 times.";
			Font font = new Font("Helvetica", Font.BOLD, 35);
			g.setFont(font);
			FontMetrics fontmetrics = g.getFontMetrics(font);
			int i = getSize().width;
			int j = getSize().height;
			int k = fontmetrics.stringWidth(chr);
			int l = (i - k) / 2;
			int i1 = ((j + fontmetrics.getMaxAscent()) - fontmetrics.getMaxDescent()) / 2;
			g.drawString(chr, l-40, i1);
			g.setFont(this.font);
			g.drawString("Credits",533,410);
			g.setColor(Color.red);
			g.drawString("LEVI",539,430);
		}
		g.setColor(Color.black);
		g.setFont(font);
		g.drawString("Points :"+ score,520,260);
		g.drawString("Level :"+ level,520,290);
		for( int i=0 ; i<numOfHeads ; i++ ){
			g.drawImage(head, 535,20 + (i * 40),this);
		}
	}

	public void decrementHeads(){
		numOfHeads--;
	}
	public void incrementScore(){
		score += 1;
	}

	public int getScore(){
		return score;
	}

	public void showScore(){
		showStatus("Score :"+score);
	}

	public void start(){
	}

	public void stop(){
	}
}

class FlapWings extends Thread{
	private Graphics handle;
	private Shooter app;
	private Image img;
	private Image blastedImage;
	private Point pos;
	private Dimension dim;
	private boolean firstTime = true;
	private boolean isBlasted = false;
	private boolean heroDead = false;
	private int posX = 10;
	private int posY = 10;
	private int oldPosX = 10;
	private int oldPosY = 10;
	private int totalDeaths = 0;
	private int flapWidth=40;
	private int flapHeight=40;

	public FlapWings(Applet app,Graphics hand){
		this.handle = hand;
		this.app = (Shooter)app;
		img = app.getImage( app.getCodeBase(), "fruit1.jpg" );
		blastedImage = app.getImage( app.getCodeBase() , "boom.jpg" );
		dim = new Dimension();
		pos = new Point();
		posX = (int)(Math.random() * (500-flapWidth));
		posY = 10;
		oldPosX = posX;
		oldPosY = posY;
	}

	public void run(){
		try{
			while(true){
				paint(handle);
				if( totalDeaths >= 3 ){
					break;
				}
				Thread.sleep(200);
			}
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public void paint(Graphics g){
		if( img == null ){
			return;
		}else if( firstTime ){
			dim.width = img.getWidth(app);
			dim.height = img.getHeight(app);
			if( dim.width == -1 || dim.height == -1 ){
				return;
			}
			firstTime = false;
		}
		int i = (int)(Math.random() * 2);
		posX = posX + ( (i==0) ? 10 : -10 );
		if( posX < 10 ){
			posX = 10;
		}else if( posX > (500-flapWidth) ){
			posX = (500-flapWidth);
		}
		posY = posY + 20;
		if( isBlasted ){
			g.drawImage(blastedImage,oldPosX,oldPosY,app);
			app.incrementScore();
			app.showScore();
			isBlasted = false;
			posX = (int)(Math.random() * (500-flapWidth));
			posY = 10;
		}else{
			g.setColor( Color.white );
			g.fillRect( oldPosX,oldPosY,dim.width,dim.height );
			g.drawImage(img,posX,posY,app);
			oldPosX = posX;
			oldPosY = posY;
		}
		if( posY > 390 ){
			oldPosX = posX;
			oldPosY = posY;
			heroDead = true;
			totalDeaths++;
			app.decrementHeads();
			app.repaint();
			posX = (int)(Math.random() * (500-flapWidth));
			posY = 10;
		}
	}

	public Point getPosition(){
		pos.x = posX;
		pos.y = posY;
		return pos;
	}

	public Dimension getImageDimension(){
		return dim;
	}

	public void setBlasted(boolean boo){
		isBlasted = boo;
	}

	public boolean getBlasted(){
		return isBlasted;
	}

	public boolean isHeroDead(){
		return heroDead;
	}

	public void setHeroDead(boolean boo){
		heroDead = boo;
	}

	public int getTotalDeaths(){
		return totalDeaths;
	}
}

class FireBullet extends Thread{
	private Graphics handle;
	private Shooter app;
	private int posX;
	private int posY = 390;
	private int oldPosY;

	public FireBullet(Applet app,Graphics hand,int posX){
		this.handle = hand;
		this.app = (Shooter)app;
		this.posX = posX;
		this.posX = this.posX + 25;
	}

	public void run(){
		try{
			while(true){
				oldPosY = posY;
				posY -= 10;
				paint(handle);
				if( posY < 10 ){
					paint(handle);
					break;
				}
				Thread.sleep(50);
			}
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public void paint(Graphics g){
		g.setColor(Color.white);
		g.fillRect( posX , oldPosY , 3, 6 );
		g.setColor(Color.red);
		g.fillRect( posX , posY , 3, 6 );
		Point pos = app.flap.getPosition();
		Dimension dim = app.flap.getImageDimension();
		if( (posX >= pos.x && posX <= (pos.x+dim.width))
			&& (posY >= pos.y && posY <=(pos.y+dim.height))
		  ){
			  app.flap.setBlasted(true);
		}
	}
}